poj3126——Prime Path(BFS)

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?

— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033

1733

3733

3739

3779

8779

8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3

1033 8179

1373 8017

1033 1033

Sample Output

6

7

0

一个四位素数变化成另一个四位素数,每次只能改变一位且改变后的数字也是素数,求最少需要改变多少次。

放在搜索分类下我才知道要用BFS。。。

#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <queue>
#include <map>
#include <algorithm>
#define INF 0x3f3f3f3f
#define MAXN 1010
using namespace std;
struct Node
{
    int a[4],step;
};
int primer[3000],cnt,vis[10000];
bool flag;
bool judge(int n)
{
    for(int i=2; i*i<=n; ++i)
        if(n%i==0)
            return false;
    return true;
}
void bfs(Node start,int m)
{
    queue<Node> q;
    q.push(start);
    while(!q.empty())
    {
        Node tmp=q.front(),tmp1;
        q.pop();
        int mm=tmp.a[0]*1000+tmp.a[1]*100+tmp.a[2]*10+tmp.a[3];
        //cout<<"mm="<<mm<<endl;
        if(mm==m)
        {
            cout<<tmp.step<<endl;
            flag=true;
            break;
        }
        tmp1=tmp;
        for(int i=1; i<=9; ++i)
        {
            tmp1.a[0]=i;
            int t=tmp1.a[0]*1000+tmp1.a[1]*100+tmp1.a[2]*10+tmp1.a[3];
            if(judge(t)&&!vis[t])
            {
                //cout<<"t0="<<t<<endl;
                vis[t]=1;
                tmp1.step=tmp.step+1;
                q.push(tmp1);
            }
            tmp1=tmp;
        }
        for(int i=0; i<=9; ++i)
        {
            for(int j=1; j<4; ++j)
            {
                tmp1.a[j]=i;
                int t=tmp1.a[0]*1000+tmp1.a[1]*100+tmp1.a[2]*10+tmp1.a[3];
                if(judge(t)&&!vis[t])
                {
                    //cout<<"t="<<t<<endl;
                    vis[t]=1;
                    tmp1.step=tmp.step+1;
                    q.push(tmp1);
                }
                tmp1=tmp;
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    int t,n,m;
    cin>>t;
    while(t--)
    {
        flag=false;
        memset(vis,0,sizeof(vis));
        cin>>n>>m;
        Node start;
        start.a[0]=n/1000;
        start.a[1]=(n/100)%10;
        start.a[2]=(n/10)%10;
        start.a[3]=n%10;
        start.step=0;
        bfs(start,m);
        if(!flag)
            cout<<"Impossible"<<endl;
    }
    return 0;
}
时间: 2024-10-29 16:57:34

poj3126——Prime Path(BFS)的相关文章

HDU - 1973 - Prime Path (BFS)

Prime Path Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 987    Accepted Submission(s): 635 Problem Description The ministers of the cabinet were quite upset by the message from the Chief of S

POJ 3126 Prime Path(BFS)

Prime Path Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 12060   Accepted: 6843 Description The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-dig

POJ 3216 Prime Path (BFS)

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. — It is a matter of security to change such things every now and then, to

Sicily 1444: Prime Path(BFS)

题意为给出两个四位素数A.B,每次只能对A的某一位数字进行修改,使它成为另一个四位的素数,问最少经过多少操作,能使A变到B.可以直接进行BFS搜索 1 #include<bits/stdc++.h> 2 using namespace std; 3 4 bool isPrime(int n){//素数判断 5 if(n == 2 || n == 3) return true; 6 else{ 7 int k = sqrt(n) + 1; 8 for(int i = 2; i < k; i

POJ 3126 Prime Path (BFS)

[题目链接]click here~~ [题目大意]给你n,m各自是素数,求由n到m变化的步骤数,规定每一步仅仅能改变个十百千一位的数,且变化得到的每个数也为素数 [解题思路]和poj 3278类似.bfs+queue,分别枚举个十百千的每一位就能够了,只是注意个位仅仅能为奇数,且千位从1開始 代码: #ifndef _GLIBCXX_NO_ASSERT #include <cassert> #endif #include <cctype> #include <cerrno&g

POJ 3126 Prime Path (bfs+欧拉线性素数筛)

Description The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. - It is a matter of security to change such things every now

POJ - 3126 - Prime Path(BFS)

Prime Path POJ - 3126 题意: 给出两个四位素数 a , b.然后从a开始,每次可以改变四位中的一位数字,变成 c,c 可以接着变,直到变成b为止.要求 c 必须是素数.求变换次数的最小值.(a,b,c都是四位数字,输入时没有前导零) 分析: 每次改变可以获得一个四位数c,然后如果c是素数并且之前没有出现过,那么我们把它放入队列即可. int f[10001]; int v[10001]; void init()//素数筛 { memset(f,0,sizeof f); fo

HDU-6705 path (bfs)

Problem Description You have a directed weighted graph with n vertexes and m edges. The value of a path is the sum of the weight of the edges you passed. Note that you can pass any edge any times and every time you pass it you will gain the weight. N

POJ 3126 Prime Path(素数路径)

p.MsoNormal { margin-bottom: 10.0000pt; font-family: Tahoma; font-size: 11.0000pt } h1 { margin-top: 5.0000pt; margin-bottom: 5.0000pt; text-align: left; font-family: 宋体; font-weight: bold; font-size: 24.0000pt } span.10 { font-family: "Times New Rom